/*************************************************************
 * CSCI P436 - Operating Systems
 *
 * John David Ratliff jdratlif@cs.indiana.edu
 * Chris O'Donnell chodonne@cs.indiana.edu
 *
 * Project 1 - Server Benchmark Client
**************************************************************/

#include <netinet/in.h>

// Constants

#define DEFAULT_HOST 		"localhost"
#define DEFAULT_PORT 		64201
#define DEFAULT_THREAD_COUNT 	50
#define DEFAULT_REQUESTS 	50

#define TOTAL_FILES 		2000

#define SBC_VERSION		"1.0.0"

enum {FAILURE=-1,SUCCESS};

/***********************************************/
// comment this line out for real runs
//#define DEBUG

// Structures

typedef struct {
	in_addr_t host_ip;
	uint16_t port;
	short int threads, requests;
} CLIENT_TRIAL_DATA;

/* Function Prototypes */

// sbc.c
void print_version_info(void);
void print_help_info(void);
void parse_command_line(int, char **, CLIENT_TRIAL_DATA *);
in_addr_t get_ip_address(char *);
short int make_server_connection(in_addr_t, uint16_t);
void *thread_work(void *);
int main(int, char **);

/******************************************************************************
 *  Server Benchmark Client 1.0.0
 *  Copyright (C) 2002 John David Ratliff [jdratlif@cs.indiana.edu]
 *                     Chris O'Donnell    [chodonne@cs.indiana.edu]
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software Foundation, 
 *  Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
******************************************************************************/

