/*************************************************************
 * CSCI P436 - Operating Systems
 *
 * John David Ratliff jdratlif@cs.indiana.edu
 * Chris O'Donnell chodonne@cs.indiana.edu
 *
 * Project 1 - Mini http Server
**************************************************************/

#ifndef _SOCKET_QUEUE_H
#define _SOCKET_QUEUE_H

#define DEFAULT_QUEUE_SIZE 100

typedef struct {
	int *queue;
	unsigned long int size, length;
	unsigned long int in, out;
} SOCKET_QUEUE;

/* socket_queue.c prototypes */

SOCKET_QUEUE *socketqueue_create(void);
void socketqueue_delete(SOCKET_QUEUE *);
short int socketqueue_is_empty(SOCKET_QUEUE *);
short int socketqueue_is_full(SOCKET_QUEUE *);
void socketqueue_enqueue(SOCKET_QUEUE *, int);
int socketqueue_dequeue(SOCKET_QUEUE *);

#endif

/******************************************************************************
 *  Mini http server 1.0.0
 *  Copyright (C) 2002 John David Ratliff [jdratlif@cs.indiana.edu]
 *                     Chris O'Donnell    [chodonne@cs.indiana.edu]
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software Foundation, 
 *  Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
******************************************************************************/

